(function(){
  var app=angular.module('DataServices');
  app.factory('CouponDataServices',function($resource,REST_BASE_URL){
    var base_url=REST_BASE_URL;
    return $resource(base_url+'/:type/:city/:couponid/:uid/:category/:page.json?m='+Math.random(),
    {},
    {
      getDailyCoupons:{
        method:'GET',
        params:{
          city:'@city',
          page:'@page',
          type:'getdailycouponsnew'
        }
      },
      getCouponDetails:{
        method:'GET',
        params:{
          couponid:'@couponid',
          uid:'@uid',
          type:'getcoupondetails'
        }
      },
      getWeeklyCoupons:{
        method:'GET',
        params:{
          city:'@city',
          type:'getdealsofweek'
        }
      },
      getCouponsByCategory:{
        method:'GET',
        params:{
          city:'@city',
          category:'@category',
          page:'@page',
          type:'getcouponsbycategorynew'
        }
      }
    });
  });
})();
