(function(){
  var app=angular.module('DataServices');
  app.factory('GeneralDataServices',function($resource,REST_BASE_URL){
    var base_url=REST_BASE_URL;
    return $resource(base_url+'/getcategories.json?m='+Math.random(),{},{
      getCategories:{
        method:'GET'
      },
      submitPromotion:{
        method:'POST',
        isArray:false,
        url: base_url+'/addpromoter.json'
      },
      changeCity:{
        method:'GET',
        isArray:false,
        url: base_url+'/changeCity/:userid/:cityid.json',
        params:{
          userid:'@userid',
          cityid:'@cityid'
        }
      },
      setUUID:{
        method:'GET',
        isArray:false,
        url:base_url+'/storeUUIDnew/:userid/:uuid/:playerid/:branch_id.json',
        params:{
          userid:'@userid',
          uuid:'@uuid',
          playerid:'@playerid',
          branch_id:'@branch_id'
        }
      },
      checkUUID:{
        method:'GET',
        url:base_url+'/checkUUID/:uuid.json',
        params:{
          uuid:'@uuid'
        }
      },
      rechargeMobile:{
        method:'POST',
        isArray:false,
        url: base_url+'/allRecharge.json'
      }
    });
  });
})();
