// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
angular.module('couponApp', ['ionic','ServicesMain','ui.router','ngCordova','ionicLazyLoad','ngAnimate'])

.run(function($ionicPlatform,$state,$cordovaSplashscreen,$ionicPopup,GAnalyticsService,$timeout,GeneralServices) {
  $ionicPlatform.ready(function() {
    // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
    // for form inputs)
    // if(window.cordova && window.cordova.plugins.Keyboard) {
    //   cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
    // }
    if(window.StatusBar) {
      StatusBar.styleDefault();
    }
    var branchIoKey='';

    //Cordova Referrals Plugin
    try{
      branch.init("key_live_omcJzfjryogoXaqg4rhY2aejExkJDkUF", function(err, data) {
        console.log('inside branch');
        console.log('data-branch-'+angular.toJson(data));

        if (!err && data.data['+clicked_branch_link']) {

          // data are the deep linked params associated with the link that the user clicked -> was re-directed to this app
          // data will be empty if no data found
          // ... insert custom routing logic here ...

        }
      });

      branch.track("install",function(err){

      });



      // branch.track("opentesting",function(err){
      //
      // });
    }catch(err){
      console.log('err-'+err);
    }

    //Splash screen
    setTimeout(function() {
      $cordovaSplashscreen.hide()
    }, 3000);



    //Notification code
    var notificationOpenedCallback = function(jsonData) {
      if(!jsonData){
        return;
      }
      // if(jsonData.isActive===true){
        var type=jsonData.additionalData.type;
        var id=jsonData.additionalData.id;
        if(type==0){
          $state.go('app.coupondetail',{id:id,params:0});
        }
        else if(type==1){
          $state.go('app.coupondetail',{id:id,params:1});
        }
        else if(type==2){
          $state.go('app.newsdetail',{newsid:id});
        }
      // }
      // else{
      //   var supportPopup = $ionicPopup.alert({
      //     title: 'New Offer!',
      //     template: 'Hey! We have a new offer for you - '+jsonData.message+'! Want to check it out?',
      //     controller:'PromoteController',
      //     buttons: [
      //       { text: 'Cancel' },
      //       {
      //         text: '<b>Check offer!</b>',
      //         type: 'button-energized',
      //         onTap: function(e) {
      //           var type=jsonData.additionalData.type;
      //           var id=jsonData.additionalData.id;
      //           if(type==0 || type==1){
      //             $state.go('app.coupondetail',{id:id});
      //           }
      //           else if(type==2){
      //             $state.go('app.newsdetail',{newsid:id});
      //           }
      //         }
      //       }
      //     ]
      //   });
      // }


    };


    // var notificationOpenedCallback = function (jsonData) {
    // console.log('Push Data: ' + JSON.stringify(jsonData));
    //
    // if (!jsonData) {
    // return;
    // }
    //
    // var returnObject = PushService.parse(jsonData);
    //
    // if (jsonData.isActive === false) {
    //
    // if (returnObject.length !== 0) {
    // $state.go(returnObject.state, returnObject.stateParams);
    // }
    // } else {
    // if (!jsonData.additionalData.title) {
    // jsonData.additionalData.title = "";
    // }
    //
    // $rootScope.appNotification = {
    // header: jsonData.additionalData.title,
    // text: jsonData.message,
    // state: returnObject.state,
    // stateParams: returnObject.stateParams,
    // show: true
    // };
    // }

    // };
    try{
      window.plugins.OneSignal.init("a0f89218-304f-11e5-bd79-ebe81df69a62",{googleProjectNumber: "635465754844",autoRegister: true},notificationOpenedCallback);
      window.plugins.OneSignal.enableVibrate(true);
    }catch(err){
      console.log('err-'+err);
    }
    // window.plugins.OneSignal.getIds(function(ids) {
    //   console.log("UserID: " + ids.userId);
    //   console.log("PushToken: " + ids.pushToken);
    //   window.plugins.uniqueDeviceID.get(function(uuid){
    //     console.log('uuid-'+uuid);
    //
    //   }, function(){
    //     console.log('err-');
    //   });
    // });
    try{
      if (localStorage.getItem("user") === null) {
        try{
          window.plugins.uniqueDeviceID.get(function(uuid){
            console.log('uuid-'+uuid);
            //Check UUID for already existing
            var resp=GeneralServices.checkUUID(uuid);
            resp.$promise.then(function(response){
              console.log('response-'+angular.toJson(response));
              if(response.response_data.AppUser){
                response.response_data.AppUser.city=response.response_data.AppUser.city_id;
                response.response_data.AppUser.username=response.response_data.AppUser.first_name;
                window.localStorage['user']=angular.toJson(response.response_data.AppUser);
                $state.go('app.topcoupons.daily');
              }
              else{
                $state.go('login');
              }
            },
            function(err){
              alert('Oops! Something went wrong fetching user! Try again.');
            });
          }, function(){
            console.log('err-');
          });
        }
        catch(err){
          console.log('err');
        }

        // if(localStorage.getItem("userunconfirmed")===null){
        //   $state.go('mobilereg');
        // }
        // else{
        //   var userunconfirmed=angular.fromJson(window.localStorage['userunconfirmed'] || '{}');
        //   $state.go('verifyotp',{userunconfirmed:angular.toJson(userunconfirmed)});
        // }
      }
      else{
        var user=angular.fromJson(window.localStorage['user'] || '{}');
        $state.go('app.topcoupons.daily',{city:user.city});
      }
    }
    catch(err){

    }
    //Google Analytics SDK
    $timeout(function () {
      GAnalyticsService.init('UA-65935333-1');
      console.log("GA Initialized UA-65935333-1");
    }, 2000);
    //window.plugins.OneSignal.enableInAppAlertNotification(true);
  });

  //Cordova Referrals Plugin On Resume
  $ionicPlatform.on("resume", function(event) {
    try{
      branch.init("key_live_omcJzfjryogoXaqg4rhY2aejExkJDkUF", function(err, data) {

      });
    }catch(err){
      console.log('err-'+err);
    }
  });
})
.config(function($urlRouterProvider,$stateProvider,$ionicConfigProvider){
  $stateProvider.state('splash',{
    url: '/splash',
    templateUrl: 'templates/splash.html',
    controller: 'SplashController'
  })
  .state('verifyotp',{
    url: '/verifyotp/:userunconfirmed',
    templateUrl: 'templates/verifyotp.html',
    controller: 'VerifyOtpController'
  })
  .state('login',{
    url: '/login',
    templateUrl: 'templates/login.html',
    controller: 'LoginController'
  })
  .state('mobilereg',{
    url: '/mobilereg',
    templateUrl: 'templates/mobilereg.html',
    controller: 'MobileRegController'
  })
  .state('app',{
    url: '/app',
    abstract: true,
    templateUrl: 'templates/menu.html',
    controller: 'MenuController'
  })
  .state('app.categorycoupons',{
    url: '/categorycoupons/:params',
    views: {
      'menuContent': {
        templateUrl: "templates/categorycoupons.html",
        controller: "CategoryCouponController"
      }
    }
  })
  .state('app.topcoupons',{
    url: '/topcoupons',
    views: {
      'menuContent': {
        templateUrl: "templates/topcoupons.html",
        controller: "TopCouponsController"
      }
    }
  })
  .state('app.topcoupons.news',{
    url: '/news',
    views: {
      'news-tab': {
        templateUrl: "templates/news.html",
        controller: "NewsController"
      }
    }
  })
  .state('app.topcoupons.daily',{
    url: '/daily',
    views: {
      'daily-tab': {
        templateUrl: "templates/daily.html",
        controller: "DailyDealsController"
      }
    }
  })
  .state('app.topcoupons.weekly',{
    url: '/weekly',
    views: {
      'weekly-tab': {
        templateUrl: "templates/weekly.html",
        controller: "WeeklyDealsController"
      }
    }
  })
  .state('app.coupondetail',{
    url: '/coupondetail/:id/:params',
    views: {
      'menuContent': {
        templateUrl: "templates/coupondetail.html",
        controller: "CouponDetailController"
      }
    }
  })
  .state('app.newsdetail',{
    url: '/topcoupons/daily/newsdetail/:newsid',
    views: {
      'menuContent': {
        templateUrl: "templates/newsdetail.html",
        controller: "NewsDetailController"
      }
    }
  });


  //$urlRouterProvider.otherwise('/splash');
  //$urlRouterProvider.otherwise('app/topcoupons/daily');

  $ionicConfigProvider.tabs.position('top'); // other values: top
})

.factory( 'GAnalyticsService', [ function () {
		var _init = function ( _account_id ) {
			try {
				window.analytics.debugMode();
				window.analytics.startTrackerWithId( _account_id );
				return true;
			} catch ( err ) {
				console.log( "Init: Error with Google Analytics"+err );
				return false;
			}
		};

		var _view = function ( _view ) {
			try {
				window.analytics.trackView( _view );
				return true;
			} catch ( err ) {
				console.log( err );
				console.log( "View: Error with Google Analytics"+err );
				return false;
			}
		};

		var _event = function ( _category, _action, _label, _value ) { //_label, _value are optional
			try {
				window.analytics.trackEvent( _category, _action, _label, _value );
				return true;
			} catch ( err ) {
				console.log( "Event: Error with Google Analytics"+err );
				return false;
			}
		};

		var _exception = function ( _description, _fatal ) { //_fatal is bool
			try {
				if ( !_fatal ) {
					_fatal = false;
				}
				window.analytics.trackException( _description, _fatal );
				return true;
			} catch ( err ) {
				console.log( "Exception: Error with Google Analytics"+err );
				return false;
			}
		};

		var _transactItem = function ( _id, _name, _sku, _category, _price, _qty, _currency ) {
			try {
				if ( !_currency ) {
					_currency = 'INR';
				}
				window.analytics.addTransactionItem( _id, _name, _sku, _category, _price, _qty, _currency );
				return true;
			} catch ( err ) {
				console.log( "Exception: Error with Google Analytics"+err );
				return false;
			}
		};

		var _userID = function ( _userID ) {
			try {
				if ( !_userID ) {
					return false;
				}
				window.analytics.setUserId( _userID );
				return true;
			} catch ( err ) {
				console.log( "Exception: Error with Google Analytics"+err );
				return false;
			}
		};


		return {
			init: _init,
			view: _view,
			event: _event,
			exception: _exception,
			transactItem: _transactItem,
			userID: _userID
		};

	} ] )
.constant('REST_BASE_URL', 'http://mycitybuzz.in/api/api')
.constant('FILE_BASE_URL', 'http://mycitybuzz.in/admin/files')
.constant('OTP_URL', 'http://t.boomsms.in/sendsms.aspx?mobile=8866016885&pass=ODYRA&senderid=MYCITY')
.constant('STORE_APP_URL', 'http://onelink.to/7phz5c');
