(function(){
  var app=angular.module('ServicesMain');
  app.factory('GeneralServices',function(GeneralDataServices,$q){
    return {
      getCategories:function(){
        var promise=GeneralDataServices.getCategories();

        promise.$promise.then(function(response){

        },function(err){

        });
        return promise;
      },
      submitPromotion:function(promotion){
        console.log('app_user_id-'+promotion.app_user_id+'-name-'+promotion.name+'-no-'+promotion.contact_no+'-email-'+promotion.email+'-desc-'+promotion.description);
        var Promoter={
          app_user_id:promotion.app_user_id,
          name:promotion.name,
          contact_no:promotion.contact_no,
          email:promotion.email,
          description:promotion.description
        }
        var data={
          'Promoter':Promoter
        }

        var promise=GeneralDataServices.submitPromotion(data);

        promise.$promise.then(function(response){

        },function(err){

        });
        return promise;
      },
      changeCity:function(userid,cityid){
        var promise=GeneralDataServices.changeCity({userid:userid,cityid:cityid});

        promise.$promise.then(function(response){

        },function(err){

        });
        return promise;
      },
      setUUID:function(userid,uuid,playerid,branchid){
        console.log('userid-'+userid+'-uuid-'+uuid+'-playerid-'+playerid+'-branchid-'+branchid);
        var promise=GeneralDataServices.setUUID({userid:userid,uuid:uuid,playerid:playerid,branch_id:branchid});

        promise.$promise.then(function(response){

        },function(err){

        });
        return promise;
      },
      checkUUID:function(uuid){
        console.log('uuid-'+uuid);
        var promise=GeneralDataServices.checkUUID({uuid:uuid});

        promise.$promise.then(function(response){

        },function(err){

        });
        return promise;
      },
      rechargeMobile:function(userid,mobile,operator,amount,type){
        console.log('userid-'+userid+'-mobile-'+mobile+'-operator-'+operator+'-amount-'+amount+'-type-'+type);
        var rechargeData={
          user_id:userid,
          mobile:mobile,
          operator:operator,
          amount:amount,
          type:type
        }
        var promise=GeneralDataServices.rechargeMobile(rechargeData);

        promise.$promise.then(function(response){

        },function(err){

        });
        return promise;
      }
    }
  });
})();
