(function(){
  var app=angular.module('couponApp');
  app.controller('CouponDetailController',['$scope','$ionicPopup','$ionicLoading','$timeout','$stateParams','CouponServices','$ionicSlideBoxDelegate','$cordovaSocialSharing','FILE_BASE_URL','$ionicHistory', 'STORE_APP_URL','$state','$ionicPlatform','GAnalyticsService', function($scope,$ionicPopup,$ionicLoading,$timeout,$stateParams,CouponServices,$ionicSlideBoxDelegate,$cordovaSocialSharing,FILE_BASE_URL,$ionicHistory, STORE_APP_URL,$state,$ionicPlatform,GAnalyticsService){
    // $scope.$on('$ionicView.beforeEnter', function (event, viewData) {
    //     viewData.enableBack = true;
    // });
    $scope.storeduser=angular.fromJson(window.localStorage['user'] || '{}');
    $scope.couponid=$stateParams.id
    $scope.category=$stateParams.params;
    try{
      GAnalyticsService.view('CouponDetail:'+$stateParams.id);
    }catch(err){

    }
    $scope.photos=[

    ]

    $scope.todolist=[

    ]

    $scope.loaded = false;
		$scope.error = false;

    $scope.showPopup = function() {
      $scope.data = {}

      // An elaborate, custom popup
      var myPopup = $ionicPopup.show({
        template: '<center><span class="badge badge-assertive">'+$scope.coupon.Offer.code+'</span></center>',
        title: 'Coupon Code',
        subTitle: 'Bingo!',
        scope: $scope,
        buttons: [
          {
            text: '<b>Ok</b>',
            type: 'button-energized'
          }
        ]
      });
    };

    $scope.getCouponDetails=function(){
      // $ionicLoading.show({
      //   content: 'Loding coupon details!',
      //   animation: 'fade-in',
      //   maxWidth: 200,
      //   showDelay: 0
      // });

      console.log('user-'+JSON.stringify($scope.storeduser));
      var resp=CouponServices.getCouponDetails($scope.couponid,$scope.storeduser.id);
      resp.$promise.then(function(response){
        // $ionicLoading.hide();
        $scope.loaded = true;
        $scope.coupon=response.response_data;
        console.log('$scope.coupon.Offer.sponsor_dir-'+$scope.coupon.Offer.sponsor_dir);
        if($scope.coupon.Offer.sponsor_dir===null||$scope.coupon.Offer.sponsor_dir==''){
          $scope.coupon.Offer.sponsor_img='img/logo-gray.jpg';
        }
        else{
          $scope.coupon.Offer.sponsor_img=FILE_BASE_URL+'/offer/sponsor_image/'+$scope.coupon.Offer.sponsor_dir+'/'+$scope.coupon.Offer.sponsor_image;
        }
        $scope.photos=response.response_data.Photo;
        for(var i=0;i<$scope.photos.length;i++){
          $scope.photos[i].imgurl=FILE_BASE_URL+'/photo/file_name/'+$scope.photos[i].file_dir+'/'+$scope.photos[i].file_name;
        }

        if(response.response_data.Address.Address.longval!==null && response.response_data.Address.Address.latval!==null){
          $scope.myLatlng = new google.maps.LatLng(response.response_data.Address.Address.latval,response.response_data.Address.Address.longval); //43.07493,-89.381388

          $scope.mapOptions = {
            center: $scope.myLatlng,
            zoom: 16,
            mapTypeId: google.maps.MapTypeId.ROADMAP
          };

        }
        // $ionicSlideBoxDelegate.update();
        $timeout(function(){
          var map = new google.maps.Map(document.getElementById("map_"+response.response_data.Offer.id),$scope.mapOptions);
        },3000);

      },
      function(err){
        $scope.error = true;
			  $scope.error_message = "Oops. Couldn't load coupon details. Please try again later or check your internet connection.";
      });
      //initialize();

    }

    $scope.shareAnywhere = function() {
      $cordovaSocialSharing.share($scope.coupon.Organisation.org_name+' - '+$scope.coupon.Offer.title + ". Download MyCityBuzz App from " + STORE_APP_URL, "Offer on MyCityBuzz", $scope.coupon.Offer.image_dir==null||$scope.coupon.Offer.image_dir==''?null:FILE_BASE_URL+'/offer/image_name/'+$scope.coupon.Offer.image_dir+'/'+$scope.coupon.Offer.image_name, "");

    }

    $scope.goBack=function(){
      console.log('cat-'+$scope.category);
      if($scope.category!='1' && $scope.category!='0'){
        var catdata=angular.fromJson($scope.category);
        $state.go('app.categorycoupons',{params:angular.toJson(catdata)});
      }
      else if($scope.category=='1'){
        //weekly
        console.log('inside weekly-');
        $state.go('app.topcoupons.weekly');
      }
      else if($scope.category=='0'){
        //daily
        console.log('inside daily-');
        $state.go('app.topcoupons.daily');
      }
      else{
        console.log('inside daily default-');
        $state.go('app.topcoupons.daily');
      }
    }

    $scope.$on( "$ionicView.enter", function( scopes, states ) {
      $ionicPlatform.registerBackButtonAction(function () {
        if($scope.category!='1' && $scope.category!='0'){
          var catdata=angular.fromJson($scope.category);
          $state.go('app.categorycoupons',{params:angular.toJson(catdata)});
        }
        else if($scope.category=='1'){
          //weekly
          $state.go('app.topcoupons.weekly');
        }
        else if($scope.category=='0'){
          //weekly
          $state.go('app.topcoupons.daily');
        }
        else{
          $state.go('app.topcoupons.daily');
        }
      }, 600);
    });


  }]);
})();
