(function(){
  var app=angular.module('couponApp');
  app.controller('LoginController',['$scope','CityServices','AuthServices','$state','$ionicLoading','$stateParams','GAnalyticsService',function($scope,CityServices,AuthServices,$state,$ionicLoading,$stateParams,GAnalyticsService){

    try{
      GAnalyticsService.view('Login');
    }
    catch(err){

    }

    $scope.user={

    };
    // $scope.receiveduser=angular.fromJson($stateParams.user);

    $scope.register=function(){
      $ionicLoading.show({
        content: 'Loading',
        animation: 'fade-in',
        maxWidth: 200,
        showDelay: 0
      });
      // $scope.user.id=$scope.receiveduser.id;
      var resp=AuthServices.register($scope.user);
      resp.$promise.then(function(response){
        $scope.cities=response.response_data;
        if(response.response_data!='failure'){
          $ionicLoading.hide();
          $scope.returneduser=response.response_data.AppUser;
          $scope.returneduser.city=$scope.returneduser.city_id;
          $scope.returneduser.username=$scope.returneduser.first_name;
          //Storing user details in tempObj
          window.localStorage['user']=angular.toJson($scope.returneduser);
          $state.go('app.topcoupons.daily');
          //$state.go('app.topcoupons',{user:angular.toJson($scope.user)});
        }
        else{
          $ionicLoading.hide();
          alert('Oops! Something went wrong! Try again.');
        }
      });

    }



    $scope.getFormData=function(){
      $ionicLoading.show({
        content: 'Loading',
        animation: 'fade-in',
        maxWidth: 200,
        showDelay: 0
      });
      var resp=CityServices.getCities();
      resp.$promise.then(function(response){
        $scope.cities=response.response_data;
        $scope.user.gender=1;
        for(var i=0;i<$scope.cities.length;i++){
          if($scope.cities[i].City.name==='Vadodara'){
            $scope.user.city=$scope.cities[i].City.id;
          }
        }
        $ionicLoading.hide();
      });
    }

  }]);
})();
