(function(){
  var app=angular.module('couponApp');
  app.controller('MobileRegController',['$scope','$state','AuthServices','$ionicLoading','$http','GAnalyticsService','OTP_URL',function($scope,$state,AuthServices,$ionicLoading,$http,GAnalyticsService,OTP_URL){
    $scope.user={};

    try{
      GAnalyticsService.view('MobileRegistration');
    }
    catch(err){

    }

    $scope.receiveotp=function(){

      $ionicLoading.show({
        content: 'Sending OTP Request',
        animation: 'fade-in',
        maxWidth: 200,
        showDelay: 0
      });

      var resp=AuthServices.receiveOtp($scope.user.mobile);
      resp.$promise.then(function(response){
        $ionicLoading.hide();
        $http.get(OTP_URL+'&to='+$scope.user.mobile+'&msg=Hi User! Welcome to MyCityBuzz. Your OTP is '+response.response_data.AppUser.opt).
        success(function(data, status, headers, config) {
          window.localStorage['userunconfirmed']=angular.toJson(response.response_data.AppUser);
          $state.go('verifyotp',{userunconfirmed:angular.toJson(response.response_data.AppUser)});
        }).
        error(function(data, status, headers, config) {
          window.localStorage['userunconfirmed']=angular.toJson(response.response_data.AppUser);
          $state.go('verifyotp',{userunconfirmed:angular.toJson(response.response_data.AppUser)});
        });
        // $state.go('verifyotp',{user:angular.toJson(response.response_data.AppUser)});
      },
      function(err){
        alert('Oops! Something went wrong! Try again.')
        $ionicLoading.hide();
      });

    }
  }]);
})();
