(function(){
  var app=angular.module('couponApp');
  app.controller('NewsController',['$scope','$state','$ionicLoading','NewsServices','$stateParams','FILE_BASE_URL','$ionicPlatform','GAnalyticsService','GeneralServices',function($scope,$state,$ionicLoading,NewsServices,$stateParams,FILE_BASE_URL,$ionicPlatform,GAnalyticsService,GeneralServices){


    //$scope.city=$stateParams.city;

    try{
      GAnalyticsService.view('NewsList');
    }
    catch(err){

    }

    //Final Changes
    var in_progress = false;
		var page = 1;
    $scope.newslist=[];
		$scope.moredata = false;
		$scope.loaded = false;
		$scope.error = false;

    $scope.storeduser=angular.fromJson(window.localStorage['user'] || '{}');
    $scope.city=$scope.storeduser.city;
    $scope.loadNews=function(hide_loading){
      // if(!hide_loading){
      //   $ionicLoading.show({
      //     content: 'Loding coupons!',
      //     animation: 'fade-in',
      //     maxWidth: 200,
      //     showDelay: 0
      //   });
      // }

      if(in_progress) { $scope.$broadcast('scroll.infiniteScrollComplete');$scope.$broadcast('scroll.refreshComplete'); return; }
			if($scope.moredata) { $scope.$broadcast('scroll.infiniteScrollComplete');$scope.$broadcast('scroll.refreshComplete'); return; }

      in_progress = true;

      if(hide_loading){
        page=1;
        $scope.newslist=[];
      }

      var resp=NewsServices.getNews($scope.city,page);
      resp.$promise.then(function(response){

        // if(!hide_loading){
        //   $ionicLoading.hide();
        // }

        $scope.loaded = true;
    		page++;
    		in_progress = false;

        if(response.response_data.length===0){
          $scope.moredata = true;
          $scope.$broadcast('scroll.infiniteScrollComplete');
          $scope.$broadcast('scroll.refreshComplete');
    			return;
        }

        for(var i=0;i<response.response_data.length;i++){
          try{
            response.response_data[i].ago=jQuery.timeago(new Date(response.response_data[i].News.published_date));

            if(response.response_data[i].News.image_dir==null||response.response_data[i].News.image_dir==''){
              response.response_data[i].News.image_path='img/logo-gray.jpg';
            }
            else{
              response.response_data[i].News.image_path=FILE_BASE_URL+'/news/image_name/'+response.response_data[i].News.image_dir+'/'+response.response_data[i].News.image_name;
            }

          }
          catch(err){
            response.response_data[i].ago='';
          }
        }

        if($scope.newslist.length == 0)
    		{
    			$scope.newslist = response.response_data;
    			return;
    		}
    		else{
	    			angular.forEach(response.response_data, function(news) {
					  this.push(news);
					}, $scope.newslist);
    		}

        if(response.response_data.length <= 6)
	    	{
					$scope.moredata = true;
				}

        $scope.$broadcast('scroll.infiniteScrollComplete');
        $scope.$broadcast('scroll.refreshComplete');

      },
      function(err){
        // alert('Oops! Something went wrong! Try again.')
        //
        // if(!hide_loading){
        //   $ionicLoading.hide();
        // }
        //
        // $scope.$broadcast('scroll.refreshComplete');
        $scope.error = true;
				$scope.error_message = "Oops. Couldn't load the news. Please try again later or check your internet connection.";
        $scope.$broadcast('scroll.refreshComplete');
      });
      $scope.$broadcast('scroll.refreshComplete');
    }

    $scope.showNewsDetail=function(newsid){
      $state.go('app.newsdetail',{newsid:newsid});
    }

    $scope.$on( "$ionicView.enter", function( scopes, states ) {
      $ionicPlatform.registerBackButtonAction(function () {
        navigator.app.exitApp();
      }, 600);
    });



  }]);
})();
