(function(){
  var app=angular.module('couponApp');
  app.controller('NewsDetailController',['$scope','$state','$ionicLoading','NewsServices','$stateParams','FILE_BASE_URL','$ionicHistory','$ionicPlatform','GAnalyticsService',function($scope,$state,$ionicLoading,NewsServices,$stateParams,FILE_BASE_URL,$ionicHistory,$ionicPlatform,GAnalyticsService){

    // $scope.$on('$ionicView.beforeEnter', function (event, viewData) {
    //     viewData.enableBack = true;
    // });

    $scope.news={};

    try{
      GAnalyticsService.view('NewsDetail:'+$stateParams.newsid);
    }
    catch(err){

    }

    $scope.loaded = false;
		$scope.error = false;

    $scope.newsid=$stateParams.newsid;

    $scope.getNewsDetail=function(){
      // $ionicLoading.show({
      //   content: 'Loding news!',
      //   animation: 'fade-in',
      //   maxWidth: 200,
      //   showDelay: 0
      // });

      var resp=NewsServices.getNewsDetail($scope.newsid);
      resp.$promise.then(function(response){
        $scope.loaded = true;
        try{
          response.response_data.ago=jQuery.timeago(new Date(response.response_data.News.published_date));

          if(response.response_data.News.image_dir==null||response.response_data.News.image_dir==''){
            response.response_data.News.image_path=null;
          }
          else{
            response.response_data.News.image_path=FILE_BASE_URL+'/news/image_name/'+response.response_data.News.image_dir+'/'+response.response_data.News.image_name;
          }

        }
        catch(err){
          response.response_data.ago='';
        }
        $scope.news=response.response_data;
        // $ionicLoading.hide();
      },
      function(err){
        $scope.error = true;
			  $scope.error_message = "Oops. Couldn't load news details. Please try again later or check your internet connection.";
      });
    }

    $scope.goBack=function(){
      // console.log('currentView-'+JSON.stringify($ionicHistory.currentView()));
      // console.log('backView-'+JSON.stringify($ionicHistory.backView()));
      $state.go('app.topcoupons.news');
    }

    $scope.$on( "$ionicView.enter", function( scopes, states ) {
      $ionicPlatform.registerBackButtonAction(function () {
        $state.go('app.topcoupons.news');
      }, 600);
    });

  }]);
})();
