(function(){
  var app=angular.module('couponApp');
  app.controller('CategoryCouponController',['$scope','$state','$stateParams','$ionicLoading','CouponServices','FILE_BASE_URL','$ionicNavBarDelegate','$ionicPlatform','GAnalyticsService',function($scope,$state,$stateParams,$ionicLoading,CouponServices,FILE_BASE_URL,$ionicNavBarDelegate,$ionicPlatform,GAnalyticsService){
    $scope.categoryReceived=angular.fromJson($stateParams.params);
    $scope.category=$scope.categoryReceived.categoryid;
    $scope.categoryname=$scope.categoryReceived.categoryname;
    console.log('category-'+$scope.category.categoryid);

    try{
      GAnalyticsService.view('Category:'+$scope.categoryname);
    }catch(err){

    }
    $ionicNavBarDelegate.showBackButton(false);

    $scope.storeduser=angular.fromJson(window.localStorage['user'] || '{}');

    //self.navigationItem.hidesBackButton = YES;

    $scope.city=$scope.storeduser.city;

    //Final Changes
    var in_progress = false;
		var page = 1;
    $scope.coupons=[];
		$scope.moredata = false;
		$scope.loaded = false;
		$scope.error = false;

    $scope.loadCoupons=function(hide_loading){
      // if(!hide_loading){
      //   $ionicLoading.show({
      //     content: 'Loding coupons!',
      //     animation: 'fade-in',
      //     maxWidth: 200,
      //     showDelay: 0
      //   });
      // }

      if(in_progress) {
        $scope.$broadcast('scroll.infiniteScrollComplete');
        if(hide_loading){
          $scope.$broadcast('scroll.refreshComplete');
        }
        return;
      }
			if($scope.moredata) {
        $scope.$broadcast('scroll.infiniteScrollComplete');
        if(hide_loading){
          $scope.$broadcast('scroll.refreshComplete');
        }
        return;
      }

      in_progress = true;

      if(hide_loading){
        page=1;
        $scope.coupons=[];
      }

      if($scope.coupons.length == 0){
				page = 1;
			}

      console.log('category-'+$scope.category);
      var resp=CouponServices.getCouponsByCategory($scope.category,$scope.city,page);
      resp.$promise.then(function(response){

        // if(!hide_loading){
        //   $ionicLoading.hide();
        // }
        $scope.loaded = true;
    		page++;
    		in_progress = false;

        if(response.response_data.length===0){
          $scope.moredata = true;
          $scope.$broadcast('scroll.infiniteScrollComplete');
          $scope.$broadcast('scroll.refreshComplete');
    			return;
        }

        //console.log('couponid-'+$scope.coupons[0].Offer.code);
        //$state.go('verifyotp',{user:angular.toJson(response.response_data.AppUser)});
        for(var i=0;i<response.response_data.length;i++){

          if(response.response_data[i].Organisation.image_dir==null||response.response_data[i].Organisation.image_dir==''){
            response.response_data[i].imgurl='img/logo-gray.jpg';
          }
          else{
            response.response_data[i].imgurl=FILE_BASE_URL+'/organisation/image_name/'+response.response_data[i].Organisation.image_dir+'/'+response.response_data[i].Organisation.image_name;
          }
        }

        if($scope.coupons.length == 0)
    		{
    			$scope.coupons = response.response_data;
          $scope.$broadcast('scroll.infiniteScrollComplete');
          $scope.$broadcast('scroll.refreshComplete');
    			return;
    		}
    		else{
	    			angular.forEach(response.response_data, function(coupon) {
					  this.push(coupon);
					}, $scope.coupons);
    		}

        if(response.response_data.length <= 6)
	    	{
					$scope.moredata = true;
				}

        $scope.$broadcast('scroll.infiniteScrollComplete');
        $scope.$broadcast('scroll.refreshComplete');

      },
      function(err){
        // alert('Oops! Something went wrong! Try again.')
        // if(!hide_loading){
        //   $ionicLoading.hide();
        // }
        // $scope.$broadcast('scroll.refreshComplete');
        $scope.error = true;
				$scope.error_message = "Oops. Couldn't load the coupons. Please try again later or check your internet connection.";
        $scope.$broadcast('scroll.refreshComplete');
      });
      $scope.$broadcast('scroll.refreshComplete');
    }

    $scope.showCouponDetails=function(couponid){
      console.log('cat-'+$scope.category);
      $state.go('app.coupondetail',{id:couponid,params:angular.toJson($scope.categoryReceived)});
    };

    $scope.$on('$stateChangeSuccess', function() {
			$scope.loadCoupons();
		});

    $scope.$on( "$ionicView.enter", function( scopes, states ) {
      $ionicPlatform.registerBackButtonAction(function () {
        navigator.app.exitApp();
      }, 600);
    });

  }]);
})();
